<!--  TABLE  -->
<div class="flexbox-column protein-table">
  <!-- OPTIONS -->
  <div style="display: flex; display: flex; justify-content: space-between">
    <mat-form-field style="width: 20%">
      <input
        matInput
        (keyup)="applyFilter()"
        placeholder="Filter"
        [(ngModel)]="filterString"
      />
    </mat-form-field>
  </div>

  <!-- MAIN-CONTENT -->
  <div style="overflow-y: auto; height: 100%" class="table-border">
    <table
      mat-table
      style="width: 100%; height: 100%"
      [dataSource]="this.groupDataSource"
      multiTemplateDataRows
      matSort
      matSortActive="proteinGroupId"
      matSortDirection="asc"
      (matSortChange)="sortTableData($event)"
    >
      <!-- NEW: Expand/Collapse Button Column -->
      <ng-container matColumnDef="expandButton">
        <th mat-header-cell *matHeaderCellDef></th>
        <td mat-cell *matCellDef="let row">
          <button
            mat-icon-button
            (click)="onExpand(row)"
            style="height: 30px; width: 30px"
          >
            <mat-icon
              [@indicatorRotate]="
                row.proteinGroupId === expandedElement
                  ? 'expanded'
                  : 'collapsed'
              "
            >
              expand_more
            </mat-icon>
          </button>
        </td>
      </ng-container>

      <ng-container matColumnDef="proteinGroupId">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>
          Protein Group ID
        </th>
        <td mat-cell class="mat-column-proteinGroupID" *matCellDef="let row">
          {{ row.proteinGroupId }}
        </td>
      </ng-container>

      <!-- <ng-container matColumnDef="groupType">
        <th mat-header-cell *matHeaderCellDef>Group Type</th>
        <td mat-cell *matCellDef="let row">{{this.getRowtype(row)}}</td>
      </ng-container> -->

      @for (column of quantificationColumns; track column) {
        <ng-container [matColumnDef]="column.expID">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>
            Quantification
          </th>
          <!-- <th mat-header-cell *matHeaderCellDef mat-sort-header>Quantification: {{column.expID}}</th> -->
          <td mat-cell class="mat-column-quantification" *matCellDef="let row">
            {{ row.quantifications[column.index] }}
          </td>
        </ng-container>
      }

      <ng-container matColumnDef="representativeAccession">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>Accession</th>
        <td
          mat-cell
          class="mat-column-representativeAccession"
          *matCellDef="let row"
        >
          {{ row.representativeAccession.accession }}
        </td>
      </ng-container>

      <ng-container matColumnDef="representativeDescription">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>Description</th>
        <td
          mat-cell
          class="mat-column-representativeDescription"
          *matCellDef="let row"
        >
          {{ row.representativeDescription.description }}
        </td>
      </ng-container>

      <ng-container matColumnDef="checkbox">
        <th mat-header-cell *matHeaderCellDef>
          <div style="display: flex; flex-direction: column">
            <div style="display: flex; justify-content: center; gap: 2px">
              <button
                class="btn btn-outline-secondary protein-table-visibility-button"
                matTooltip="Disable selected groups"
                (click)="disableSelectedGroups()"
              >
                <mat-icon
                  style="transform: scale(0.7) translate(-0.7em, -0.7em)"
                  >visibility_off</mat-icon
                >
              </button>
              <button
                class="btn btn-outline-secondary protein-table-visibility-button"
                matTooltip="Enable selected groups"
                (click)="enableSelectedGroups()"
              >
                <mat-icon
                  style="transform: scale(0.7) translate(-0.7em, -0.7em)"
                  >visibility</mat-icon
                >
              </button>
            </div>
            <mat-checkbox
              [(ngModel)]="selectedAll"
              (change)="onSelectAllGroups()"
            ></mat-checkbox>
          </div>
        </th>
        <td class="mat-column-checkbox" mat-cell *matCellDef="let row">
          <mat-checkbox
            [(ngModel)]="row.isSelected"
            (change)="onSelectGroup(row)"
          >
          </mat-checkbox>
        </td>
      </ng-container>

      <ng-container matColumnDef="expandedDetail">
        <!-- [@detailExpand]="row.proteinGroupID !== expandedElement ? 'expanded' : 'collapsed'" -->
        <!-- <td style="width: 100%; padding-left:0;padding-right:0;" -->
        <td
          mat-cell
          *matCellDef="let row"
          [attr.colspan]="displayedColumns.length"
        >
          <!-- <div [@detailExpand]="row.proteinGroupID == expandedElement ? 'expanded' : 'collapsed'"> -->
          <!-- <div *ngIf="row.proteinGroupID !== expandedElement"> -->

          <!-- SUBROWS -->
          <table style="width: 100%; border-collapse: collapse">
            <!-- <tr
            *ngFor="let subrow of expandedSubgroups"
            (click)="onClick(subrow)"
            class="subgroup-row"
            [ngClass]="{
              'table-highlight-row': false,
              'table-element-row': true,
              'table-disabled-row': false,
              'subgroup-row': true,
              'checkbox-selected': false,
            }"
          > -->
            <tr *ngFor="let subrow of expandedSubgroups">
              <td class="mat-column-expandButton"></td>
              <td class="mat-column-proteinGroupID">
                {{ subrow.proteinGroupId }}
              </td>
              @for (column of quantificationColumns; track column) {
                <ng-container>
                  <td class="mat-column-quantification">
                    {{ subrow.quantifications[column.index] }}
                  </td>
                </ng-container>
              }
              <td class="mat-column-representativeAccession">
                {{ subrow.representativeAccession.accession }}
              </td>
              <td class="mat-column-representativeDescription">
                {{ subrow.representativeDescription.description }}
              </td>
              <td class="mat-column-checkbox">
                <mat-checkbox [(ngModel)]="subrow.isSelected"></mat-checkbox>
              </td>
            </tr>
          </table>
          <!-- </div> -->
        </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
      <tr
        mat-row
        *matRowDef="let row; columns: displayedColumns"
        (click)="onClick(row)"
        class="group-row"
        [ngClass]="{
          'table-highlight-row': row.isHighlighted,
          'table-element-row': row.isDisplayed,
          'table-disabled-row': !row.isDisplayed,
          'checkbox-selected': row.isSelected,
        }"
      ></tr>
      <tr
        mat-row
        *matRowDef="let row; columns: ['expandedDetail']"
        class="table-detail-row"
        [hidden]="row.proteinGroupId !== expandedElement"
      ></tr>
    </table>
  </div>
  <!-- PAGINATOR AND PAGE-SIZE -->
  <div
    style="
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      width: 100%;
      align-items: center;
    "
  >
    <button mat-raised-button color="accent" (click)="downloadGroups()">
      Export Groups
    </button>
    <mat-paginator
      #paginator
      style="background: none"
      [pageSizeOptions]="[5, 10, 25, 100]"
      showFirstLastButtons
    ></mat-paginator>
  </div>
  <div
    style="
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      width: 100%;
      align-items: center;
    "
  >
    <button
      mat-raised-button
      color="accent"
      (click)="downloadGroupsAndSubgroups()"
    >
      Export Groups & Subgroups
    </button>
  </div>

  <!-- PROTEINGROUP-DETAILS -->
  <ng-container *ngIf="this.highlightedGroup !== null">
    <div class="flexbox-column">
      <cdk-accordion>
        <cdk-accordion-item
          [expanded]="false"
          #accordionItem="cdkAccordionItem"
          role="button"
          tabindex="0"
          [attr.id]="'accordion-header'"
          [attr.aria-expanded]="accordionItem.expanded"
          [attr.aria-controls]="'accordion-body'"
          class="details-accordion-item"
        >
          <!-- OPTIONS / CLICKABLE-BAR -->
          <div
            (click)="accordionItem.toggle()"
            class="details-accordion-item-header"
          >
            <p class="details-accordion-item-header-text">
              <span class="click-hint">
                {{ accordionItem.expanded ? "🔼" : "🔽" }} Press here for
                details:
              </span>
              Group
              {{
                accordionItem.expanded
                  ? "displaying group "
                  : "show details for group "
              }}
              {{ this.highlightedGroup.proteinGroupId }}
            </p>
          </div>

          <!-- CONTENT -->
          <!-- <ng-container *ngIf="showDetails"> -->
          <div
            class="details-accordion-item-body"
            role="region"
            [style.display]="accordionItem.expanded ? '' : 'none'"
            [attr.id]="'accordion-body'"
            [attr.aria-labelledby]="'accordion-header'"
          >
            <app-proteingroup-detail-view
              class="detail-table"
              style="
                min-height: 0;
                min-width: 0;
                display: flex;
                flex-direction: column;
              "
            >
            </app-proteingroup-detail-view>
          </div>
          <!-- </ng-container> -->
        </cdk-accordion-item>
      </cdk-accordion>
    </div>
  </ng-container>
</div>
